.p02


.include "nes.h"
.import clearMap, clearLineImg, copyLineImg, putTile, vwfPuts
.export chrData

.segment "INESHDR"

  .byt "NES", 26
  .byt 2  ; number of 16 KB program segments
  .byt 0  ; number of 8 KB chr segments
  .byt $20  ; mapper, mirroring, etc
  .byt $20  ; extended mapper info
  .byt 0,0,0,0,0,0,0,0  ; f you DiskDude

.segment "ZEROPAGE"
vblanked:  .res 1

.segment "CODE"

nmihandler:
  inc vblanked
irqhandler:
  rti

main:

;;; Init CPU
  sei
  cld
  ldx #$ff
  txs
  inx
  stx PPUCTRL
  stx PPUMASK

;;; Init PPU
:
  bit $2002
  bpl :-
:
  bit $2002
  bpl :-

;;; Load initial palette
  lda #$3f
  sta PPUADDR
  stx PPUADDR
@palclrloop:
  lda pal,x
  sta PPUDATA
  inx
  lda pal,x
  sta PPUDATA
  inx
  cpx #32
  bne @palclrloop

;;; Load initial chr
  jsr clearLineImg
  ldy #0
  ldy #0
  sty PPUADDR
  sty PPUADDR
  lda #28
  sta 8
:
  jsr copyLineImg
  dec 8
  bne :-


;;; Clear nametable $2000
  lda #$20
  sta PPUADDR
  lda #0
  sta PPUADDR
  jsr clearMap

;;; Write msg
  lda #$02
  sta PPUADDR
  lda #$00
  sta PPUADDR

  jsr clearLineImg
  lda #>copr
  ldy #<copr
  ldx #8
  jsr vwfPuts
  jsr copyLineImg

  jsr clearLineImg
  lda #>strike1
  ldy #<strike1
  ldx #8
  jsr vwfPuts
  jsr copyLineImg

  jsr clearLineImg
  lda #>strike2
  ldy #<strike2
  ldx #8
  jsr vwfPuts
  jsr copyLineImg

  jsr clearLineImg
  lda #>strike3
  ldy #<strike3
  ldx #8
  jsr vwfPuts
  jsr copyLineImg

  jsr clearLineImg
  jsr copyLineImg
  lda #>line1
  ldy #<line1
  ldx #8
  jsr vwfPuts
  jsr copyLineImg
  jsr clearLineImg
  lda #>line2
  ldy #<line2
  ldx #8
  jsr vwfPuts
  jsr copyLineImg
  jsr clearLineImg
  lda #>line3
  ldy #<line3
  ldx #8
  jsr vwfPuts
  jsr copyLineImg
  jsr clearLineImg
  lda #>line4
  ldy #<line4
  ldx #8
  jsr vwfPuts
  jsr copyLineImg

  lda #$80
  sta PPUCTRL


main_loop:
  lda vblanked
  beq main_loop
  lda #0
  sta vblanked

;;; turn on display
  lda #0
  sta PPUSCROLL
  sta PPUSCROLL
  lda #$80
  sta PPUCTRL
  lda #PPUMASK_BG0
  sta PPUMASK

  jmp main_loop




;;; draw_text:
;   Draws a nul-terminated line of text to the screen.
;   0: pointer to text src
;   X: high word of dst
;   Y: low word of dst
;   out: Y: length of string; A: 0
draw_text:
  stx PPUADDR
  sty PPUADDR
  ldy #0
  lda (0),y
  beq @skip
@loop:
  sta PPUDATA
  iny
  lda (0),y
  bne @loop
@skip:
  rts


.segment "RODATA"
.align 256
chrData:
  .incbin "hello.chr"

copr:    .asciiz "VWF Demo 0.01  2006 Damian Yerrick"
strike1: .byt "[ !",$22,"#$%&'()*+,-./0123456789:;<=>?]",0
strike2: .asciiz "[@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_]"
strike3: .asciiz "[`abcdefghijklmnopqrstuvwxyz{|}~]"

line1: .asciiz "This text is written with a variable width font."
line2: .asciiz "Variable width fonts are easier on the user's eyes"
line3: .asciiz "than fixed width fonts for programs that use a lot"
line4: .asciiz "of text, such as RPGs and e-books."

pal:
  .byt $30,$0f,$30,$0f,$30,$30,$0f,$0f,$30,$34,$34,$34,$30,$34,$34,$34
  .byt $30,$0f,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30

@die:
  jmp @die


.segment "VECTORS"

  .addr nmihandler, main, irqhandler
